/*---------------------------------------------------------------------
 * lm-slider.js - JavaScript for the MSTW League Manager Sliders
 *
 *	MSTW Wordpress Plugins (http://shoalsummitsolutions.com)
 *	Copyright 2016-18 Mark O'Donnell (mark@shoalsummitsolutions.com)
 *
 *	This program is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation, either version 3 of the License, or
 *	(at your option) any later version.

 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 *---------------------------------------------------------------------*/

jQuery(document).ready( function( $ ) {
	//console.log( "document is ready" );
	//console.log( 'in document.ready: isGlobal= ' + isGlobal );
	//isGlobal = 'READY';
	//console.log( 'isGlobal is reset:' + isGlobal );
	
	//
	// The number [0 thru N-1] of the next game is stored in the hidden
	// game-number element. This game is always going to appear when the 
	// page loads.
	//
	// Using that field to loop through all sliders on the page
	//
	$(".lms-game-number").each( function ( ) {
		var startingGame = $( this ).data( 'game-number' );
		//console.log( "startingGame: " + startingGame );
	
		var suff = $( this ).attr( 'id' ).replace( 'lms-game-number', '');
		//console.log( "suff: " + suff );
		
		var gameBlockWidth = $( '.lms-slider-content' + suff + ' li.lms-list-item' ).outerWidth( true );
		//console.log ("game block width: " + gameBlockWidth );
			
		var totalGames = $( '.lms-slider-content' + suff + ' ul li.lms-list-item' ).length;
		//console.log ("total games: " + totalGames );
		
		//
		// Reduce the width of the slider content to what is really needed
		//
		$( '.lms-slider-content' + suff ).css( { 'width' : gameBlockWidth * totalGames } );
		//console.log( "content" + suff + " width: " + $( '.lms-slider-content' + suff ).css( 'width' ) );
		
		$( '.lms-slider-content' + suff + ' ul').css( { 'width' : gameBlockWidth * totalGames } );
		//console.log( "content" + suff + " ul width: " + $( '.lmt-ticker-content' + suff + ' ul').css( 'width' ) );
		
		var viewportWidth  = $( '.lms-viewport' + suff ).outerWidth( );
		//console.log( "viewport width: = " + viewportWidth );
	
		//var blockHeight = parseInt( $( '.lms-slider-content' + suff + ' .lms-list-item' ).css('height'));
		//console.log ("slider content " + suff + " block height: " + blockHeight );
		
		var maxHeight = Math.max.apply(null, $( '.lms-slider-content' + suff + ' .lms-list-item' ).map(function ()
											{
													return $(this).height();
											}).get());
	
		$('.lms-viewport' + suff ).css( { 'min-height' : maxHeight } );
		
		//console.log ("slider viewport " + suff + " height: " + $('.lms-viewport' + suff ).css( 'min-height' ) );
		
		var rightStop = -( totalGames*gameBlockWidth - viewportWidth );
		//console.log ("right stop: " + rightStop );
		
		var newLeftPos = Math.max( 0 - gameBlockWidth * startingGame, rightStop );
		// console.log ("new left position: " + newLeftPos );
	
		//
		// Set the slider 'tape' (game list) so the starting game is visible on the right
		// First game with date >= current date
		//
		$('.lms-viewport' + suff + ' ul').css( {'left' : newLeftPos } );
		
	} ); //End: $(".lms-game-number").each
	
	//
	// Handle click on NEXT arrow - move right
	//
	$('.lms-next').click( function( ) {
		//console.log( "SLIDER RIGHT ARROW CLICKED" );
		
		var suff = $( this ).attr('id').replace('lms-next', '');
		//console.log( 'suff = ' + suff );
		
		var slider_id = '.lms-slider-content' + suff;
		//console.log( "slider_id = " + slider_id );
		
		var gameBlockWidth = $(slider_id + ' li.lms-list-item').outerWidth();
		//console.log( 'gameBlockWidth = ' + gameBlockWidth );

		var viewportWidth = $('.lms-viewport'+suff).outerWidth( );
		//console.log( 'viewportWidth = ' + viewportWidth );
		
		var nbrBlocks = Math.floor( viewportWidth/gameBlockWidth );
		//console.log( 'nbrBlocks = ' + nbrBlocks );
		
		var hiddenBit = ( nbrBlocks + 1 )* gameBlockWidth - viewportWidth; 
		//console.log( 'hiddenBit = ' + hiddenBit );
		
		var totalGames = $( slider_id + ' ul li.lms-list-item').length;
		//console.log( 'totalGames = ' + totalGames );
		
		if ( totalGames >= nbrBlocks ) {
			
			var currLeftPos = parseInt($('.lms-viewport' + suff + ' ul').css('left'));
			//console.log( 'currLeftPos = ' + currLeftPos );
			
			var rightStop = -( totalGames*gameBlockWidth - viewportWidth ); //works
			//console.log( 'orig rightStop = ' + rightStop );
			//rightStop += gameBlockWidth;
			//rightStop -= hiddenBit;
			//console.log( 'proposed rightStop = ' + rightStop );
			
			var slideDistance = ( totalGames <= 1 ) ? gameBlockWidth : Math.floor( viewportWidth/gameBlockWidth ) * gameBlockWidth;
			//console.log( 'slideDistance = ' + slideDistance );
			
			var newLeftPos = Math.max( currLeftPos - slideDistance, rightStop );
			
			var newLeftPosFloor = Math.floor( newLeftPos / gameBlockWidth );
			//console.log( "New left pos floor:" + newLeftPosFloor );
		
			var evenLeftPos = newLeftPosFloor * gameBlockWidth;
			//console.log( 'evenLeftPos = ' + evenLeftPos );
			
			$( '.lms-viewport' + suff + ' ul' ).css( { 'left' : evenLeftPos } );
			
		} //End: if( totalGames >= nbrBlocks ) else 
		
	}); //End: ('.lms-next').click(
	
	//
	// Handle click on PREV arrow - move left
	//
	$( '.lms-prev' ).click( function( ){
		//console.log( 'in lms-prev.click: left arrow was clicked' );
		
		var suff = $( this ).attr('id').replace( 'lms-prev', '' );
		//console.log( 'suff = ' + suff );
		
		var slider_id = '.lms-slider-content' + suff;
		//console.log( "slider_id = " + slider_id );
		
		var gameBlockWidth = $( slider_id + ' li.lms-list-item' ).outerWidth( );
		//console.log( 'gameBlockWidth = ' + gameBlockWidth );

		var viewportWidth = $( '.lms-viewport' + suff ).outerWidth( );
		//console.log( 'viewportWidth = ' + viewportWidth );
		
		var nbrBlocks = Math.floor( viewportWidth / gameBlockWidth );
		//console.log( 'nbrBlocks = ' + nbrBlocks );
		
		//var hiddenBit = ( nbrBlocks + 1 )* gameBlockWidth - viewportWidth; 
		//console.log( 'hiddenBit = ' + hiddenBit );
		
		var totalGames = $( slider_id + ' ul li.lms-list-item').length;
		//console.log( 'totalGames = ' + totalGames );
		
		if ( totalGames >= nbrBlocks ) {
			
			var currLeftPos = parseInt($('.lms-viewport' + suff + ' ul').css('left'));
			//console.log( 'currLeftPos = ' + currLeftPos );
			
			var slideDistance = ( totalGames <= 1 ) ? gameBlockWidth : Math.floor( viewportWidth/gameBlockWidth ) * gameBlockWidth;
			//console.log( 'slideDistance = ' + slideDistance );
			
			// leftStop is always 0
			var newLeftPos = Math.min( currLeftPos + slideDistance, 0 );
			//console.log( "New left pos:" + newLeftPos );
			
			var newLeftPosFloor = Math.floor( newLeftPos / gameBlockWidth );
			//console.log( "New left pos floor:" + newLeftPosFloor );
		
			var evenLeftPos = newLeftPosFloor * gameBlockWidth;
			//console.log( "Even left pos floor:" + evenLeftPos );
			
			$( '.lms-viewport' + suff + ' ul' ).css( {'left' : evenLeftPos } );
			
		} //End: if ( totalGames >= nbrBlocks )
			
	}); //End: lmsPrev.click( )
	
}); //End: document ready