/*---------------------------------------------------------------------
 * lm-ticker.js - JavaScript for the MSTW League Manager tickers
 *
 * 	Note: Tickers are intended for use at the top of a page as a summary
 *		ala espn.com, cbssports.com, etc, etc. 
 *
 *	MSTW Wordpress Plugins (http://shoalsummitsolutions.com)
 *	Copyright 2016-18 Mark O'Donnell (mark@shoalsummitsolutions.com)
 *
 *	This program is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation, either version 3 of the License, or
 *	(at your option) any later version.

 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 *---------------------------------------------------------------------*/

jQuery(document).ready( function( $ ) {
	//console.log( "document is ready" );
	//console.log( 'in document.ready: isGlobal= ' + isGlobal );
	//isGlobal = 'READY';
	//console.log( 'isGlobal is reset:' + isGlobal );
	
	//
	// The number [0 thru N-1] of the next game is stored in the hidden
	// game-number element. This game is always going to appear when the 
	// page loads.
	//
	// Using that field to loop through all tickers on the page
	//
	$(".lmt-game-number").each( function ( ) {
		var startingGame = $( this ).data( 'game-number' );
		//console.log( "startingGame: " + startingGame );
	
		var suff = $( this ).attr( 'id' ).replace( 'lmt-game-number', '');
		//console.log( "suff: " + suff );
		
		var gameBlockWidth = $( '.lmt-ticker-content' + suff + ' li.lmt-list-item' ).outerWidth( true );
		//console.log ("game block width: " + gameBlockWidth );
			
		var totalGames = $( '.lmt-ticker-content' + suff + ' ul li.lmt-list-item' ).length;
		//console.log ("total games: " + totalGames );
		
		//
		// Reduce the width of the ticker content to what is really needed
		//
		$( '.lmt-ticker-content' + suff ).css( { 'width' : gameBlockWidth * totalGames } );
		//console.log( "content" + suff + " width: " + $( '.lmt-ticker-content' + suff ).css( 'width' ) );
		
		$( '.lmt-ticker-content' + suff + ' ul').css( { 'width' : gameBlockWidth * totalGames } );
		//console.log( "content" + suff + " ul width: " + $( '.lmt-ticker-content' + suff + ' ul').css( 'width' ) );
		
		var viewportWidth  = $( '.lmt-viewport' + suff ).outerWidth( );
		//console.log( "viewport width: = " + viewportWidth );
	
		//var blockHeight = parseInt( $( '.lmt-ticker-content' + suff + ' .lmt-list-item' ).css('height'));
		//console.log ("ticker content " + suff + " block height: " + blockHeight );
		
		//
		// Set the viewport height to what is really needed
		//
		var maxHeight = Math.max.apply(null, $( '.lmt-ticker-content' + suff + ' .lmt-list-item' ).map(function ()
											{
													return $(this).height();
											}).get());
											
		$('.lmt-viewport' + suff ).css( { 'min-height' : maxHeight } );
											
		//$('.lmt-viewport' + suff ).css( { 'min-height' : blockHeight } );
		//console.log ("ticker viewport " + suff + " height: " + $('.lmt-viewport' + suff ).css( 'min-height' ) );
		
		var rightStop = -( totalGames*gameBlockWidth - viewportWidth );
		//console.log ("right stop: " + rightStop );
		
		var newLeftPos = Math.max( 0 - gameBlockWidth * startingGame, rightStop );
		//console.log ("new left position: " + newLeftPos );
	
		//
		// Set the ticker tape (game list) so the starting game is visible on the right
		// First game with date >= current date
		//
		$('.lmt-viewport' + suff + ' ul').css( {'left' : newLeftPos } );
		
	} ); //End: $(".lmt-game-number").each
	
	//
	// Handle click on NEXT arrow - move right
	//
	$( '.lmt-next' ).click( function( ) {
		//console.log( 'TICKER RIGHT ARROW CLIKED' );
		
		var suff = $( this ).attr('id').replace('lmt-next', '');
		//console.log( 'suff = ' + suff );
		
		var ticker_id = '.lmt-ticker-content' + suff;
		//console.log( "ticker_id = " + ticker_id );
		
		var gameBlockWidth = $( ticker_id + ' li.lmt-list-item' ).outerWidth();
		//console.log( 'gameBlockWidth = ' + gameBlockWidth );

		var viewportWidth = $( '.lmt-viewport' + suff ).outerWidth( );
		//console.log( 'viewportWidth = ' + viewportWidth );
		
		var nbrBlocks = Math.floor( viewportWidth/gameBlockWidth );
		//console.log( 'nbrBlocks = ' + nbrBlocks );
		
		var hiddenBit = ( nbrBlocks + 1 )* gameBlockWidth - viewportWidth; 
		//console.log( 'hiddenBit = ' + hiddenBit );
		
		var totalGames     = $( ticker_id + ' ul li.lmt-list-item').length;
		//console.log( 'totalGames = ' + totalGames );
		
		if ( totalGames >= nbrBlocks ) {
			
			var currLeftPos = parseInt($( '.lmt-viewport' + suff + ' ul' ).css( 'left' ) );
			
			var rightStop = -( totalGames*gameBlockWidth - viewportWidth );
			//console.log( "right stop is: " + rightStop );
			
			var slideDistance = ( totalGames <= 1 ) ? gameBlockWidth : Math.floor( viewportWidth/gameBlockWidth ) * gameBlockWidth;
			//console.log( 'slideDistance = ' + slideDistance );
			
			var newLeftPos = Math.max( currLeftPos - slideDistance, rightStop );
			
			var newLeftPosFloor = Math.floor( newLeftPos / gameBlockWidth );
			//console.log( "New left pos floor:" + newLeftPosFloor );
			
			var evenLeftPos = newLeftPosFloor * gameBlockWidth;
			//console.log( "evenLeftPos:" + evenLeftPos );
			
			$( '.lmt-viewport' + suff + ' ul' ).css( { 'left' : evenLeftPos } );
			
		} //End: if( totalGames >= nbrBlocks ) else 
		
	}); //End: ('.lmt-next').click(
	
	//
	// Handle click on PREV arrow - move left
	//
	$('.lmt-prev').click(function() {	
		//console.log( 'in lmt-prev.click: left arrow was clicked' );
		
		var suff = $( this ).attr('id').replace( 'lmt-prev', '' );
		//console.log( "suffix: " + suff );
		
		var ticker_id = '.lmt-ticker-content' + suff;
		//console.log( "ticker_id = " + ticker_id );
		
		var gameBlockWidth = $( ticker_id + ' li.lmt-list-item' ).outerWidth( true );
		//console.log( 'gameBlockWidth = ' + gameBlockWidth );
		
		var viewportWidth = $( '.lmt-viewport' + suff ).outerWidth( );
		//console.log( 'viewportWidth = ' + viewportWidth );
		
		var nbrBlocks = Math.floor( viewportWidth / gameBlockWidth );
		//console.log( 'nbrBlocks = ' + nbrBlocks );
		
		//var hiddenBit = ( nbrBlocks + 1 )* gameBlockWidth - viewportWidth; 
		//console.log( 'hiddenBit = ' + hiddenBit );
		
		var totalGames = $( ticker_id + ' ul li.lmt-list-item').length;
		//console.log( 'totalGames = ' + totalGames );
	
		if ( totalGames >= nbrBlocks ) {
			
			var currLeftPos = parseInt( $( '.lmt-viewport' + suff + ' ul' ).css( 'left' ) );
			//console.log( 'currLeftPos = ' + currLeftPos );
			
			var slideDistance = ( totalGames <= 1 ) ? gameBlockWidth : Math.floor( viewportWidth / gameBlockWidth ) * gameBlockWidth;
			//console.log( 'slideDistance = ' + slideDistance );
			
			// leftStop is always 0
			var newLeftPos = Math.min( currLeftPos + slideDistance, 0 );
			//console.log( "New left pos:" + newLeftPos );
			
			var newLeftPosFloor = Math.floor( newLeftPos / gameBlockWidth );
			//console.log( "New left pos floor:" + newLeftPosFloor );
			
			var evenLeftPos = newLeftPosFloor * gameBlockWidth; 
			//console.log( "Even left pos floor:" + evenLeftPos );
		
			$( '.lmt-viewport' + suff + ' ul' ).css( { 'left' : evenLeftPos } );
			
		}	//End: if ( totalGames >= nbrBlocks )
			
	}); //End: lmtPrev.click( )
	
}); //End: document ready