<?php
/**-------------------------------------------------------------------------
 * MSTW League Manager single game template.
 *
 * NOTE: Plugin users/site admins may have to modify this template to 
 * "fit" their individual themes. This template has been tested with
 * the WordPress Twenty Eleven and Twenty Twelve themes. 
 *
 *	MSTW Wordpress Plugins (http://shoalsummitsolutions.com)
 *	Copyright 2014-18 Mark O'Donnell (mark@shoalsummitsolutions.com)
 *
 *	This program is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation, either version 3 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program. If not, see <//www.gnu.org/licenses/>.
 *-------------------------------------------------------------------------*/
 ?>

<?php get_header(); ?>

<div id="primary">
 <div id="content" role="main">

	<?php while ( have_posts() ) : the_post(); ?>
		<!-- Navigation back to previous page -->
		<!--
		<nav id="nav-single">
			<h3 class="assistive-text"><?php _e( 'Post navigation', 'mstw-league-manager' ); ?></h3>
			<span class="nav-previous">
				<?php //$back =$_SERVER['HTTP_REFERER'];
				//if( isset( $back ) && $back != '' ) { 
					//echo '<a href="' . $back . '">';?>
					<span class="meta-nav">&larr;</span><?php //_e( 'Previous Page', 'mstw-league-manager' ) ?></a>
				<?php
				//}?>
			</span> <!-- .nav-previous 	
		</nav><!-- #nav-single
		-->

		<article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
		 <?php
		 //
		 // PULL THE GAME DATA
		 //
		 //
		 
		 // Should pull sport from game (somehow), then get options
		 // Or maybe not
		 $options = mstw_lm_get_sport_options( 'football-ncaa' );
		 //mstw_log_msg( "single page: options:" );
		 //mstw_log_msg( $options );
		
		 // Game ID
		 $game_ID  = get_the_ID( );
		 $game_obj = get_post( );
		
		 // find the home team
		 $home_team_slug = get_post_meta( $game_ID, 'game_home_team', true );
		 $home_team_obj = get_page_by_path( $home_team_slug, OBJECT, 'mstw_lm_team' );
		
		 // find the away team
		 $away_team_slug = get_post_meta( $game_ID, 'game_away_team', true );
		 $away_team_obj = get_page_by_path( $away_team_slug, OBJECT, 'mstw_lm_team' );
		
		 $is_home_game = get_post_meta( $game_ID, 'game_home_score', true ); 
		 $home_css_tag = ( $is_home_game ) ? 'mstw-ss-home' : '';
		 
		 // Game date & time
		 $unix_timestamp = get_post_meta( $game_ID, 'game_unix_dtg', true );
		 
		 // Time and date formats //could use gallery formats
		 $date_format = $options['date_format']; 
		 $time_format = $options['time_format']; 
		 
		 $game_is_final = get_post_meta( $game_ID, 'game_is_final', true );
		 $game_is_ppd = get_post_meta( $game_ID, 'game_is_ppd', true );
		 $game_is_tba = get_post_meta( $game_ID, 'game_is_tba', true );
		 
		 $status_replace = get_post_meta( $game_ID, 'game_status_replace', true );
		 $status_append  = get_post_meta( $game_ID, 'game_status_append', true );
		 
		 $game_name = get_post_meta( $game_ID, 'game_name', true );
		 
		 ?>
			
		 <div class="single-game single-game_<?php echo( $home_team_slug ) ?> <?php echo $home_css_tag ?>">
		  <!--
		  Build the date-time header block
		  -->
		  <div class='date-time-block'>
			<?php echo date( 'l, j F Y', $unix_timestamp) ?>
			</div>
			
			<?php if ( $game_name ) { ?>
			<div class='date-time-block'>
				<?php echo $game_name; ?>
			</div>
			<?php }?>
		
		  <div class="single-game-sb-block">
		    <!--
		    Build the home team block
		    -->
			<div class="sb-team-block sb-home">
			  <?php echo mstw_lm_build_team_logo( $home_team_slug, 'large' ) ?>
			  <p>
			  <?php echo mstw_lm_get_team_name( $game_obj, 'home', $options, 'name_mascot' )?>
			  </p>
			</div> <!-- .sb-team-block -->
			 
			<?php
			//
			// Build the status block
			//
			$home_score = get_post_meta( $game_ID, 'game_home_score', true );
			$away_score = get_post_meta( $game_ID, 'game_away_score', true );
	
			$status_entry = '';
			$score_entry  = '';
			
			if ( $game_is_ppd ) {
					$status_entry = __( 'PPD', 'mstw-league-manager' );
					
			} else {
				if ( !empty( $home_score ) && !empty( $away_score ) ) {
					// We gonna ass-u-me game is in progress or final
					$score_entry = "$home_score - $away_score";
					if ( $game_is_final ) {
						$status_entry = __( 'FINAL', 'mstw-league-manager' );
					}
					else {
						$status_entry = get_post_meta( $game_ID, 'game_time_remaining', true ) .'  ' . mstw_lm_numeral_to_ordinal( (int)get_post_meta( $game_ID, 'game_period', true ) );
					}					
				} else {
					// We gonna show the game time or TBA
					if ( $game_is_tba ) {
						$status_entry = __( 'TBA', 'mstw-league-manager' );
					} else {
						//$status_entry = "Game time";
						$status_entry = date( $time_format, $unix_timestamp );
					}
					
				} //End if ( !empty( $home_score ) && !empty( $away_score ) )
				
			} //End if ( $game_is_ppd ) {
			
			if ( $status_replace ) {
				$status_entry = $status_replace;
				
			} else if ( $status_append ) {
				$status_entry = "$status_entry $status_append";
				
			}
			
			// Added media icon for Summit City Sports
			$media_entry = '';
			$media_link  = get_post_meta( $game_ID, 'game_media_link', true );
			if ( $media_link != '' ) {
				$media_icon = mstw_lm_media_icon_url( );
				//$videoImageURL = plugin_dir_url( __DIR__ ) . "images/mstw-video-icon.png";
				//mstw_log_msg( "video image: $videoImageURL" );
				//mstw_log_msg( "media found for game: " . $game -> post_name );
				$media_entry = "<a class='lm-media-link' href='$media_link' target='_blank'><img src='$media_icon'/></a>";
			}
			
			?>
			
			<div class="sb-data">
			 <?php if ( !$status_replace ) {?>
				<div class="sb-score">
			  <?php echo $score_entry ?>
				</div>
			 <?php } ?>
			 
			 <div class="sb-status">
			  <?php echo $status_entry ?>
			 </div>
			 
			 <div class="sb-media">
			  <?php echo $media_entry ?>
			 </div>
			</div> <!-- .sb-data -->
			 
			<!--
			Build the away team block
			-->
			<div class="sb-team-block sb-away">
			 <?php echo mstw_lm_build_team_logo( $away_team_slug, 'large' ) ?>
			 <p>
			  <?php echo mstw_lm_get_team_name( $game_obj, 'visitor', $options, 'name_mascot' )?>
			 </p>
			</div> <!-- .sb-team-block -->
			 
		  </div> <!-- .single-game-sb-block -->
			
			
		  <?php
		  //
		  // Build the location block
		  //
		  $game_location = mstw_lm_get_game_location( $game_obj, $options, $format = null );
		  //mstw_log_msg( "game location: $game_location" );
		  ?>
		  <div class='single-game-venue'>
			<?php echo $game_location ?>
		  </div>
		  <?php
		  //
		  // Build the content block
		  //
		  ?>
		  <div class='single-game-content'>
				<?php the_content( ); ?>
		  </div>
		  
		 </div> <!-- .single-game -->
			
		</article> <!-- #post-<?php the_ID(); ?> -->

	<?php endwhile; // end of the loop. ?>

 </div><!-- #content -->
</div><!-- #primary -->

<?php get_footer();?>